UNIT mTSpielmanager;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses SysUtils, Dialogs;

type
   TSpielmanager = CLASS

     // weitere Attribute
     private
        FHolz : array[1..3] of integer;
        FBotschaft : string;
        FSpieler : string;
        FSpieler1 : string;
        FSpieler2 : string;

     // weitere Methoden
     public
        procedure neuesSpiel(spieler1,spieler2:string);
        procedure verarbeiteEingabe(haufen,anzahl:integer);
        function GetBotschaft : string;
        function GetHoelzchenZahl(haufen : integer) : integer;

   end;

implementation

//+---------------------------------------------------------------------
//|         TSpielmanager: Methodendefinition 
//+---------------------------------------------------------------------

//-------- neuesSpiel (public) -----------------------------------------
procedure TSpielmanager.neuesSpiel(spieler1,spieler2:string);
begin
  FSpieler1 := spieler1; FSpieler2 := spieler2;
  FSpieler := FSpieler1;
  FHolz[1] := 3; FHolz[2] := 4; FHolz[3] := 5;
  FBotschaft := FSpieler+' ist am Zug.';
end;

//-------- verarbeiteEingabe (public) ----------------------------------
procedure TSpielmanager.verarbeiteEingabe(haufen,anzahl:integer);
begin
  if (1 <= anzahl) and 
     (anzahl <= FHolz[haufen]) 
  then
    begin
      FHolz[haufen] := FHolz[haufen] - anzahl;
      if FHolz[1]+FHolz[2]+FHolz[3] = 0
      then
        FBotschaft := FSpieler+' hat gewonnen!'
      else
        begin
          if FSpieler = FSpieler1
          then FSpieler := FSpieler2
          else FSpieler := FSpieler1;
          FBotschaft := FSpieler+' ist am Zug.';
        end;
    end
  else
    showMessage('Unzulssige Eingabe!');
end;

//-------- GetBotschaft (public) ---------------------------------------
function TSpielmanager.GetBotschaft : string;
   begin
      result  := FBotschaft
   end;

//-------- GetHoelzchenZahl (public) -----------------------------------
function TSpielmanager.GetHoelzchenZahl(haufen : integer) : integer;
begin
  result := FHolz[haufen];
end;

end.
